credit_requests/urls.py
from django.conf.urls import include, url
from django.contrib.auth import views as auth_views
from .views import (
    CreditRequestCreateAPIView,
    CreditRequestDeleteView,
    CreditRequestFormView,
    CreditRequestListView,
    CreditRequestUpdateView
)

urlpatterns = [
    # Non authenticated users urls
    url(
        r'^$',
        CreditRequestFormView.as_view(),
        name='credit_request_form_view'
    ),
    # Login and Logout urls
    url(r'^accounts/', include([
        url(
            r'^login/$',
            auth_views.login,
            {'template_name': 'credit_requests/login.html'},
            name='login'
        ),
        url(
            r'^logout/$',
            auth_views.logout,
            {'next_page': 'login'},
            name='logout'
        ),
    ])),
    # Administration ruls
    url(r'^administration/', include([
        url(r'^credit_request/', include([
            url(
                r'^$',
                CreditRequestListView.as_view(),
                name='credit_request_list_view'
            ),
            url(r'^(?P<pk>\d+)/', include([
                url(
                    r'^update/$',
                    CreditRequestUpdateView.as_view(),
                    name='credit_request_update_view'
                ),
                url(
                    r'^delete/$',
                    CreditRequestDeleteView.as_view(),
                    name='credit_request_delete_view'
                ),
            ])),

        ])),
    ])),
    # API urls
    url(r'^api/', include([
        url(r'^credit_requests/', include([
            url(r'^create/$',
                CreditRequestCreateAPIView.as_view(),
                name='credit_request_create_api_view'),
        ])),
    ])),
]

moni/urls.py
from django.conf.urls import include, url
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('credit_requests.urls')),
]

credit_requests/models.py
from decimal import Decimal
from django.core.validators import MinValueValidator
from django.db import models
from django.utils.translation import ugettext_lazy as _


class CreditRequest(models.Model):
    """
    A class for storing Credit Requests of users
    """
    MIN_DOCUMENT_NUMBER = Decimal(1000000)
    MALE, FEMALE = 'M', 'F'
    GENDER_CHOICES = (
        (MALE, _("Masculino")),
        (FEMALE, _("Femenino")),
    )
    MIN_AMMOUNT = Decimal(0)
    PENDING, APPROVED, DISAPPROVED, DATA_ERROR, REQUEST_ERROR = list(range(5))
    RESULT_CHOICES = (
        (PENDING, _("Solicitud pendiente")),
        (APPROVED, _("Solicitud Aprobada")),
        (DISAPPROVED, _("Solucitud Desaprobada")),
        (DATA_ERROR, _("Los datos de la solicitud son incorrectos")),
        (REQUEST_ERROR, _("Hubo un error al analizar la solicitud"))
    )

    document_number = models.DecimalField(
        max_digits=8,
        decimal_places=0,
        validators=[MinValueValidator(MIN_DOCUMENT_NUMBER)],
        verbose_name="DNI"
    )
    name = models.CharField(max_length=256, verbose_name="Nombre")
    surname = models.CharField(max_length=256, verbose_name="Apellido")
    gender = models.CharField(
        max_length=1,
        choices=GENDER_CHOICES,
        default=MALE,
        verbose_name="Genero"
    )
    email = models.EmailField()
    ammount = models.DecimalField(
        max_digits=9,
        decimal_places=2,
        validators=[MinValueValidator(MIN_AMMOUNT)],
        verbose_name="Monto"
    )
    result = models.PositiveSmallIntegerField(
        choices=RESULT_CHOICES,
        default=PENDING,
        verbose_name="Resultado"
    )

credit_requests/forms.py
from django.forms import ModelForm
from .models import CreditRequest


class CreditRequestForm(ModelForm):
    """
    Form to create a credit request
    """
    class Meta:
        model = CreditRequest
        fields = [
            'document_number', 'name', 'surname', 'gender', 'email', 'ammount'
        ]

credit_requests/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.urlresolvers import reverse_lazy
from django.views.generic import DeleteView, FormView, ListView, UpdateView
from rest_framework.generics import CreateAPIView
from rest_framework.renderers import JSONRenderer
from .scoring_integrations.moni import MoniScorer
from .forms import CreditRequestForm
from .models import CreditRequest
from .serializers import CreditRequestCreateSerializer


class CreditRequestFormView(FormView):
    """
    View to render the form used to send a credit request
    """
    form_class = CreditRequestForm
    template_name = 'credit_requests/credit_request_form.html'


class CreditRequestCreateAPIView(CreateAPIView):
    """
    API View to create the credit request and return the result
    """
    renderer_classes = (JSONRenderer,)
    serializer_class = CreditRequestCreateSerializer

    def perform_create(self, serializer):
        # Saving the CreditRequest
        credit_request = serializer.save()
        # Getting the score
        scorer = MoniScorer(
            document_number=credit_request.document_number,
            gender=credit_request.gender,
            email=credit_request.email
        )
        credit_request.result = scorer.get_score()
        credit_request.save()


class CreditRequestListView(LoginRequiredMixin, ListView):
    """
    View to list credit requests
    """
    model = CreditRequest
    template_name = 'credit_requests/credit_request_list.html'


class CreditRequestUpdateView(LoginRequiredMixin, UpdateView):
    """
    View to update a credit
    """
    model = CreditRequest
    fields = [
        'document_number', 'name', 'surname', 'gender', 'email', 'ammount',
        'result'
    ]
    template_name = 'credit_requests/credit_request_update.html'
    success_url = reverse_lazy('credit_request_list_view')


class CreditRequestDeleteView(LoginRequiredMixin, DeleteView):
    model = CreditRequest
    template_name = 'credit_requests/credit_request_delete.html'
    success_url = reverse_lazy('credit_request_list_view')

credit_requests/templates/credit_requests/base.html
<!DOCTYPE html>
<html>
<head>
	<title>{% block title %}{% endblock title %}</title>
	<!--Import Google Icon Font-->
	<link href="http://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
	<!--Import materialize.css-->
	{% load static %}
	<link type="text/css" rel="stylesheet" href="{% static 'credit_requests/css/materialize.min.css' %}"  media="screen,projection"/>
	
	<meta name="viewport" content="width=device-width, initial-scale=1.0"/>
	<meta charset="UTF-8">
	<meta name="mobile-web-app-capable" content="yes">
	<script type="text/javascript" src="{% static 'credit_requests/js/cookies.min.js' %}"></script>

	<script type="text/javascript" src="{% static 'credit_requests/js/jquery-3.2.1.min.js' %}"></script>
	<script type="text/javascript" src="{% static 'credit_requests/js/materialize.min.js' %}"></script>
	{% block head %}{% endblock head %}
</head>
<body>
	<header>
		<nav class="top-nav teal">
			<div class="container">
				<div class="nav-wrapper">
					<a class="brand-logo center">{% block nav_title %}{% endblock nav_title %}</a>
					<ul class="right">{% block nav_right %}{% endblock nav_right %}</ul>			
				</div>
			</div>
		</nav>
	</header> 
	<main>
		<div class="main-container">
			<div class="row">
				<div class="col s12 m12 l12">
					{% block content %}{% endblock content %}
				</div>
			</div>
		</div>
	</main>
</body>
</html>

credit_requests/templates/credit_requests/base_priv.html
{% extends "credit_requests/base.html" %}
{% block nav_right %}
<!-- Dropdown Trigger -->
<li><a class="dropdown-button" href="#!" data-activates="dropdownusr">¡Hola {{user}}!<i class="material-icons right">arrow_drop_down</i></a></li>
<!-- Dropdown Structure -->
<ul id='dropdownusr' class='dropdown-content'>
	<li><a href="{% url 'logout' %}">Cerrar Sesión</a></li>
</ul>
{% endblock nav_right %}
						

credit_requests/templates/credit_requests/credit_request_delete.html
{% extends "credit_requests/base_priv.html" %}
{% block title %}Eliminar solicitud{% endblock title %}
{% block nav_title %}Eliminar Solicitud{% endblock nav_title %}
{% block content %}
<div class="row">
  <form class="col s4 offset-s4" method="post">
    {% csrf_token %}
    <div class="row">
    	<h5 class='.center-align'>¿Está seguro que desea eliminar la solicitud #{{ object.pk }}?</h5>
    </div>
    <div class="row">
      <div class="col s12">
        <button class="btn waves-effect waves-light" style="width: 100%;" type="submit" name="action">Eliminar<i class="material-icons right">send</i></button>
      </div>
    </div>
  </form>
</div>
{% endblock content %}

credit_requests/templates/credit_requests/credit_request_form.html
{% extends "credit_requests/base.html" %}
{% block head %}
{% load static %}
<script type="text/javascript" src="{% static 'credit_requests/js/credit_request_form.js' %}"></script>
{% endblock head %}
{% block title %}Solicitud de Prestamos{% endblock title %}
{% block nav_title %}Solicitud de Prestamos{% endblock nav_title %}
{% block content %}

  <div class="row">
    <form class="col s4 offset-s4" method="post">
      {% csrf_token %}
      <div class="row">
        <div class="input-field col s12">
          {{form.document_number}}
          <label for="password">{{form.document_number.label}}</label>
          <div class='validation_errors' id='document_number_error'></div>
        </div>
      </div>	
      <div class="row">
        <div class="input-field col s6">
          {{form.name}}
          <label for="name">{{form.name.label}}</label>
          <div class='validation_errors' id='name_error'></div>
        </div>
        <div class="input-field col s6">
          {{form.surname}}
          <label for="surname">{{form.surname.label}}</label>
          <div class='validation_errors' id='surname_error'></div>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s12">
          {{form.email}}
          <label for="email">{{form.email.label}}</label>
          <div class='validation_errors' id='email_error'></div>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s12">
          {{form.gender}}
          <label for="gender">{{form.gender.label}}</label>
          <div class='validation_errors' id='gender_error'></div>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s12">
          {{form.ammount}}
          <label for="ammount">{{form.ammount.label}}</label>
          <div class='validation_errors' id='ammount_error'></div>
        </div>
      </div>
      <div class="row">
        <div class="col s12">
          <button class="btn waves-effect waves-light" id='action_submit' style="width: 100%;" type="submit" name="action" target_url="{% url 'credit_request_create_api_view' %}">Enviar<i class="material-icons right">send</i></button>
        </div>
      </div>
    </form>
  </div>


<!-- Modal result -->
<div id="modal_result" class="modal">
  <div class="modal-content">
    <h4>Resultado</h4>
    <p id='modal_result_text'></p>
  </div>
  <div class="modal-footer">
    <a href="#!" class="modal-action modal-close waves-effect waves-green btn-flat">Aceptar</a>
  </div>
</div>

<!-- Modal loader -->
<div id="modal_loader" class="modal">
  <div class="modal-content">
    <h4>Procesando Solicitud</h4>
    <div class="progress">
        <div class="indeterminate"></div>
    </div>
  </div>
</div>

{% endblock content %}

credit_requests/templates/credit_requests/credit_request_list.html
{% extends "credit_requests/base_priv.html" %}
{% block title %}Listado de Solicitudes{% endblock title %}
{% block nav_title %}Listado de Solicitudes{% endblock nav_title %}
{% block content %}
<table class="striped responsive-table">
  <thead>
    <tr>
        <th>ID</th>
        <th>DNI</th>
        <th>Nombre</th>
        <th>Apellido</th>
        <th>Genero</th>
        <th>Email</th>
        <th>Monto</th>
        <th>Resultado</th>
        <th>Acciones</th>
    </tr>
  </thead>

  <tbody>
    {% for credit_request in object_list %}
    <tr>
      <td>{{ credit_request.id }}</td>
      <td>{{ credit_request.document_number }}</td>
      <td>{{ credit_request.name }}</td>
      <td>{{ credit_request.surname }}</td>
      <td>{{ credit_request.get_gender_display }}</td>
      <td>{{ credit_request.email }}</td>
      <td>{{ credit_request.ammount }}</td>
      <td>{{ credit_request.get_result_display }}</td>
      <td>
        <a class="btn-floating btn-small waves-effect waves-light teal" href="{% url 'credit_request_update_view' credit_request.id %}"><i class="material-icons">mode_edit</i></a>
        <a class="btn-floating btn-small waves-effect waves-light red" href="{% url 'credit_request_delete_view' credit_request.id %}"><i class="material-icons">delete</i></a>
      </td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock content %}

credit_requests/templates/credit_requests/credit_request_update.html
{% extends "credit_requests/base_priv.html" %}
{% block title %}Actualizar solicitud{% endblock title %}
{% block head %}
{% load static %}
<script type="text/javascript" src="{% static 'credit_requests/js/credit_request_update.js' %}"></script>
{% endblock head %}
{% block nav_title %}Actualizar Solicitud{% endblock nav_title %}
{% block content %}
<div class="row">
  <form class="col s4 offset-s4" method="post">
    {% csrf_token %}
    {{form.as_p}}
    <div class="row">
      <div class="col s12">
        <button class="btn waves-effect waves-light" style="width: 100%;" type="submit" name="action">Actualizar<i class="material-icons right">send</i></button>
      </div>
    </div>
  </form>
</div>
{% endblock content %}

credit_requests/templates/credit_requests/login.html
{% extends "credit_requests/base.html" %}
{% block title %}Iniciar Sesión{% endblock title %}
{% block nav_title %}Iniciar Sesión{% endblock nav_title %}
{% block content %}

  <div class="row">
    <form class="col s4 offset-s4" method="post">
      {% csrf_token %}
      {{form.as_p}}
      <div class="row">
        <div class="col s12">
          <button class="btn waves-effect waves-light" style="width: 100%;" type="submit" name="action">Iniciar Sesión<i class="material-icons right">send</i></button>
        </div>
      </div>
    </form>
  </div>

{% endblock content %}